<html>
<head>
<title>OgreGpuProgramParams.h File Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#nested-classes">Classes</a> &#124;
<a href="#namespaces">Namespaces</a> &#124;
<a href="#typedef-members">Typedefs</a> &#124;
<a href="#enum-members">Enumerations</a>  </div>
  <div class="headertitle">
<div class="title">OgreGpuProgramParams.h File Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><code>#include &quot;<a class="el" href="OgrePrerequisites_8h_source.html">OgrePrerequisites.h</a>&quot;</code><br/>
<code>#include &quot;<a class="el" href="OgreSharedPtr_8h_source.html">OgreSharedPtr.h</a>&quot;</code><br/>
<code>#include &quot;<a class="el" href="OgreIteratorWrappers_8h_source.html">OgreIteratorWrappers.h</a>&quot;</code><br/>
<code>#include &quot;<a class="el" href="OgreSerializer_8h_source.html">OgreSerializer.h</a>&quot;</code><br/>
<code>#include &quot;<a class="el" href="OgreRenderOperation_8h_source.html">OgreRenderOperation.h</a>&quot;</code><br/>
<code>#include &quot;<a class="el" href="OgreAny_8h_source.html">OgreAny.h</a>&quot;</code><br/>
</div>
<p><a href="OgreGpuProgramParams_8h_source.html">Go to the source code of this file.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="nested-classes"></a>
Classes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1GpuConstantDefinition.html">Ogre::GpuConstantDefinition</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Information about predefined program constants.  <a href="structOgre_1_1GpuConstantDefinition.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1GpuNamedConstants.html">Ogre::GpuNamedConstants</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Struct collecting together the information for named constants.  <a href="structOgre_1_1GpuNamedConstants.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GpuNamedConstantsSerializer.html">Ogre::GpuNamedConstantsSerializer</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Simple class for loading / saving <a class="el" href="structOgre_1_1GpuNamedConstants.html" title="Struct collecting together the information for named constants.">GpuNamedConstants</a>.  <a href="classOgre_1_1GpuNamedConstantsSerializer.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1GpuLogicalIndexUse.html">Ogre::GpuLogicalIndexUse</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Structure recording the use of a physical buffer by a logical parameter index.  <a href="structOgre_1_1GpuLogicalIndexUse.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1GpuLogicalBufferStruct.html">Ogre::GpuLogicalBufferStruct</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Container struct to allow params to safely &amp; update shared list of logical buffer assignments.  <a href="structOgre_1_1GpuLogicalBufferStruct.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GpuSharedParameters.html">Ogre::GpuSharedParameters</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">A group of manually updated parameters that are shared between many parameter sets.  <a href="classOgre_1_1GpuSharedParameters.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GpuSharedParametersUsage.html">Ogre::GpuSharedParametersUsage</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">This class records the usage of a set of shared parameters in a concrete set of <a class="el" href="classOgre_1_1GpuProgramParameters.html" title="Collects together the program parameters used for a GpuProgram.">GpuProgramParameters</a>.  <a href="classOgre_1_1GpuSharedParametersUsage.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1GpuSharedParametersUsage_1_1CopyDataEntry.html">Ogre::GpuSharedParametersUsage::CopyDataEntry</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GpuProgramParameters.html">Ogre::GpuProgramParameters</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Collects together the program parameters used for a <a class="el" href="classOgre_1_1GpuProgram.html" title="Defines a program which runs on the GPU such as a vertex or fragment program.">GpuProgram</a>.  <a href="classOgre_1_1GpuProgramParameters.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1GpuProgramParameters_1_1AutoConstantDefinition.html">Ogre::GpuProgramParameters::AutoConstantDefinition</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Structure defining an auto constant that's available for use in a parameters object.  <a href="structOgre_1_1GpuProgramParameters_1_1AutoConstantDefinition.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1GpuProgramParameters_1_1AutoConstantEntry.html">Ogre::GpuProgramParameters::AutoConstantEntry</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Structure recording the use of an automatic parameter.  <a href="classOgre_1_1GpuProgramParameters_1_1AutoConstantEntry.html#details">More...</a><br/></td></tr>
<tr><td colspan="2"><h2><a name="namespaces"></a>
Namespaces</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">namespace &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespaceOgre.html">Ogre</a></td></tr>
<tr><td colspan="2"><h2><a name="typedef-members"></a>
Typedefs</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef map&lt; String, <br class="typebreak"/>
GpuConstantDefinition &gt;::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Materials.html#ga90b266af540c4396c8c18ac2c43fd0f3">Ogre::GpuConstantDefinitionMap</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef ConstMapIterator<br class="typebreak"/>
&lt; GpuConstantDefinitionMap &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Materials.html#gaff7bf5891ea6cfed80f4e50edc5d3695">Ogre::GpuConstantDefinitionIterator</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef SharedPtr<br class="typebreak"/>
&lt; GpuNamedConstants &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Materials.html#gab76650f27b9b671a6ad6ba0e466c65aa">Ogre::GpuNamedConstantsPtr</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef map&lt; size_t, <br class="typebreak"/>
GpuLogicalIndexUse &gt;::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Materials.html#ga2275e636e8d9bbe23e350ef676e289b5">Ogre::GpuLogicalIndexUseMap</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef SharedPtr<br class="typebreak"/>
&lt; GpuLogicalBufferStruct &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Materials.html#ga2292a2b9e147e50617d24746070bbc9f">Ogre::GpuLogicalBufferStructPtr</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef vector&lt; float &gt;::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Materials.html#ga85c9b7d7f5d35f36d118af514f18ab5b">Ogre::FloatConstantList</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Definition of container that holds the current float constants.  <a href="group__Materials.html#ga85c9b7d7f5d35f36d118af514f18ab5b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef vector&lt; int &gt;::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Materials.html#ga0f6f75258759920f3879eb1b4b590121">Ogre::IntConstantList</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Definition of container that holds the current float constants.  <a href="group__Materials.html#ga0f6f75258759920f3879eb1b4b590121"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef SharedPtr<br class="typebreak"/>
&lt; GpuSharedParameters &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Materials.html#ga4bbf05af668b0deefaf7b0c0f172d45b">Ogre::GpuSharedParametersPtr</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Shared pointer used to hold references to <a class="el" href="classOgre_1_1GpuProgramParameters.html" title="Collects together the program parameters used for a GpuProgram.">GpuProgramParameters</a> instances.  <a href="group__Materials.html#ga4bbf05af668b0deefaf7b0c0f172d45b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef SharedPtr<br class="typebreak"/>
&lt; GpuProgramParameters &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Materials.html#gaebab7cecf3f3ae81a1fbfa08ab36f2b5">Ogre::GpuProgramParametersSharedPtr</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Shared pointer used to hold references to <a class="el" href="classOgre_1_1GpuProgramParameters.html" title="Collects together the program parameters used for a GpuProgram.">GpuProgramParameters</a> instances.  <a href="group__Materials.html#gaebab7cecf3f3ae81a1fbfa08ab36f2b5"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="enum-members"></a>
Enumerations</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Materials.html#ga9c5b2950be06ff56a6ee0bace240d447">Ogre::GpuConstantType</a> { <br/>
&#160;&#160;<a class="el" href="group__Materials.html#gga9c5b2950be06ff56a6ee0bace240d447a2e6d0cad211d29d14774e0ca147dcd30">Ogre::GCT_FLOAT1</a> =  1, 
<a class="el" href="group__Materials.html#gga9c5b2950be06ff56a6ee0bace240d447a979f39c4955889813f82374df96f6181">Ogre::GCT_FLOAT2</a> =  2, 
<a class="el" href="group__Materials.html#gga9c5b2950be06ff56a6ee0bace240d447abf2aed5efd251c030794ec27a7174fc8">Ogre::GCT_FLOAT3</a> =  3, 
<a class="el" href="group__Materials.html#gga9c5b2950be06ff56a6ee0bace240d447a466febc90367dab6c895c98edfff7681">Ogre::GCT_FLOAT4</a> =  4, 
<br/>
&#160;&#160;<a class="el" href="group__Materials.html#gga9c5b2950be06ff56a6ee0bace240d447a99d7d2b7976d0ef3b940f01e017b54ed">Ogre::GCT_SAMPLER1D</a> =  5, 
<a class="el" href="group__Materials.html#gga9c5b2950be06ff56a6ee0bace240d447a4f4eec3ce315c9a1ed97f47689241b64">Ogre::GCT_SAMPLER2D</a> =  6, 
<a class="el" href="group__Materials.html#gga9c5b2950be06ff56a6ee0bace240d447a18d1b343f2ec603945d3d7875622637a">Ogre::GCT_SAMPLER3D</a> =  7, 
<a class="el" href="group__Materials.html#gga9c5b2950be06ff56a6ee0bace240d447a13e953e084eb700f0bf55a42f6cae138">Ogre::GCT_SAMPLERCUBE</a> =  8, 
<br/>
&#160;&#160;<a class="el" href="group__Materials.html#gga9c5b2950be06ff56a6ee0bace240d447a37ce33389359aac73400ae427d9920fa">Ogre::GCT_SAMPLER1DSHADOW</a> =  9, 
<a class="el" href="group__Materials.html#gga9c5b2950be06ff56a6ee0bace240d447acea2c4e9feb93413f97ce9c045269a50">Ogre::GCT_SAMPLER2DSHADOW</a> =  10, 
<a class="el" href="group__Materials.html#gga9c5b2950be06ff56a6ee0bace240d447adcacdabe1213322ebee0bc64ac4db387">Ogre::GCT_SAMPLER2DARRAY</a> =  11, 
<a class="el" href="group__Materials.html#gga9c5b2950be06ff56a6ee0bace240d447a0b2767a1b36c8e7821979adb15615c7a">Ogre::GCT_MATRIX_2X2</a> =  12, 
<br/>
&#160;&#160;<a class="el" href="group__Materials.html#gga9c5b2950be06ff56a6ee0bace240d447abd03cb2cf3acde19f3a348e6146dd3e9">Ogre::GCT_MATRIX_2X3</a> =  13, 
<a class="el" href="group__Materials.html#gga9c5b2950be06ff56a6ee0bace240d447a964c921cd7327eb271da6eb78742a850">Ogre::GCT_MATRIX_2X4</a> =  14, 
<a class="el" href="group__Materials.html#gga9c5b2950be06ff56a6ee0bace240d447a80cbab72631a6efe3feaed44bf01e97e">Ogre::GCT_MATRIX_3X2</a> =  15, 
<a class="el" href="group__Materials.html#gga9c5b2950be06ff56a6ee0bace240d447a0128d0683a17c232bb249a068c65cbd7">Ogre::GCT_MATRIX_3X3</a> =  16, 
<br/>
&#160;&#160;<a class="el" href="group__Materials.html#gga9c5b2950be06ff56a6ee0bace240d447a87a7bc0df0623b02534894a90d634f6d">Ogre::GCT_MATRIX_3X4</a> =  17, 
<a class="el" href="group__Materials.html#gga9c5b2950be06ff56a6ee0bace240d447a33f4e8ee7271ce5353aa53c04c18447d">Ogre::GCT_MATRIX_4X2</a> =  18, 
<a class="el" href="group__Materials.html#gga9c5b2950be06ff56a6ee0bace240d447a5b26aaa1925eaa7bb83dd4a9e25b28d5">Ogre::GCT_MATRIX_4X3</a> =  19, 
<a class="el" href="group__Materials.html#gga9c5b2950be06ff56a6ee0bace240d447a01541907f48e2d56b7198a4076996a43">Ogre::GCT_MATRIX_4X4</a> =  20, 
<br/>
&#160;&#160;<a class="el" href="group__Materials.html#gga9c5b2950be06ff56a6ee0bace240d447ad023a5c54e29999cee04d54971cc5691">Ogre::GCT_INT1</a> =  21, 
<a class="el" href="group__Materials.html#gga9c5b2950be06ff56a6ee0bace240d447afce84063333829487cd0401fca732092">Ogre::GCT_INT2</a> =  22, 
<a class="el" href="group__Materials.html#gga9c5b2950be06ff56a6ee0bace240d447a18edb505f8205cfed6bb28da3abefd53">Ogre::GCT_INT3</a> =  23, 
<a class="el" href="group__Materials.html#gga9c5b2950be06ff56a6ee0bace240d447a278c0c55560cb39e67ce17239dc8184e">Ogre::GCT_INT4</a> =  24, 
<br/>
&#160;&#160;<a class="el" href="group__Materials.html#gga9c5b2950be06ff56a6ee0bace240d447a3b3c9d05e75e6c20fd106d0f0080ad7e">Ogre::GCT_UNKNOWN</a> =  99
<br/>
 }</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Enumeration of the types of constant we may encounter in programs.  <a href="group__Materials.html#ga9c5b2950be06ff56a6ee0bace240d447">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__Materials.html#ga167c785d87088b52526f1f079024fcda">Ogre::GpuParamVariability</a> { <br/>
&#160;&#160;<a class="el" href="group__Materials.html#gga167c785d87088b52526f1f079024fcdaa756d7f053db5b3bc0d38c15d98cda93f">Ogre::GPV_GLOBAL</a> =  1, 
<a class="el" href="group__Materials.html#gga167c785d87088b52526f1f079024fcdaa39d4c360141a21c7dd916c7837b357af">Ogre::GPV_PER_OBJECT</a> =  2, 
<a class="el" href="group__Materials.html#gga167c785d87088b52526f1f079024fcdaad782ae3173a29e4a2e28215489c5147b">Ogre::GPV_LIGHTS</a> =  4, 
<a class="el" href="group__Materials.html#gga167c785d87088b52526f1f079024fcdaa30bc7bdcc3f0930c8dfb66c70eaecf4d">Ogre::GPV_PASS_ITERATION_NUMBER</a> =  8, 
<br/>
&#160;&#160;<a class="el" href="group__Materials.html#gga167c785d87088b52526f1f079024fcdaa76c85c18f88b57983f861ee83fccde4a">Ogre::GPV_ALL</a> =  0xFFFF
<br/>
 }</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">The variability of a GPU parameter, as derived from auto-params targeting it.  <a href="group__Materials.html#ga167c785d87088b52526f1f079024fcda">More...</a><br/></td></tr>
</table>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:53
</p>
</body>
</html>
